      subroutine Complex_Spectrum( datain, dt, npts, 
     :    prcntfrtapr, cspect, npw2, df, sign)

c Returns the complex spectrum.
c The program applies a tapered window to the
c front and back of the time series, pads with zeros, and computes the
c spectrum.

c Written by D. M. Boore

* Dates: 10/28/92 - Created by modifying Abs_Spectra


      real DATAIN(*) 
      complex CSPECT(*)
      real DATA(16400)
      complex CX(16400)

c Fill working array with input data:

      do i = 1, npts
         data(i) = datain(i)
      end do

c
c     remove dc, apply taper, pad with zeros
c
      call dcdt(data, dt, npts, 1, npts, .true., .false.)

      ifront = prcntfrtapr
      iback = prcntfrtapr
      call fbctpr (ifront, iback, data, npts)

      call zeropad2( data, npts, npts, npw2)

c sample rate and frequency spacing:

      sr = 1.0 / dt
      tlength = float(npw2)* dt
      df = 1.0/ tlength

      npw2d2 = npw2 / 2

c Fill working complex array

      do j = 1, npw2
        cx(j)=cmplx(data(j), 0.0)
      end do

c     FFT to get spectrum

      call fork(npw2,cx, sign)

* Scale properly:

      inyq = npw2d2+1

      do j =1 ,inyq
        cspect(j)=cx(j)*dt*sqrt(float(npw2))
      end do

* Make sure the value at Nyquist is real:
        cspect(inyq) = cmplx(real(cspect(inyq)),0.0)

      return
      end
