* ----------------------------- BEGIN GET_AMP_PHASE --------------------------
      subroutine get_amp_phase(y, npts, dt, amp, phase)

* Dates: 02/24/99 - written by D. Boore
*        05/21/02 - Used cmplx in filling work, use allocatable array for work

      real y(*), amp(*), phase(*)
      complex work(:)

      allocatable :: work

      allocate (work(npts+2))

      do i = 1, npts
        work(i) = cmplx(y(i), 0.0)
      end do
      call fork(npts,work,1.0)

      do i = 1, npts
        amp(i) = cabs(work(i))
        if (aimag(work(i)) .eq. 0.0 .and. 
     :       real(work(i)) .eq. 0.0)  then
          phase(i) = 0.0
        else
          phase(i) = atan2( aimag(work(i)), real(work(i)) )
        end if
      end do
      
      deallocate (work)

      return
      end
* ----------------------------- END GET_AMP_PHASE --------------------------

