* ------------------------------------------------------------------ rmv_mean
      subroutine rmv_mean(a_in, a_out, npts, sps, 
     :                    t4mean_strt, t4mean_stop, avg)

* Determine mean from portion of time series "a" between t4mean_strt
* and t4mean_stop, and remove this mean from the whole time series.
* Can specify no mean removed by setting t4mean_stop .le. 0.0.  Setting
* t4mean outside of the actual limits of the time series will force 
* a redefinition of the times to the actual limits.

* Dates: 09/21/00 - Written by D. Boore
*        06/03/09 - Replace avg_dbl = 0.0 with avg_dbl = 0.0d0

      real a_in(*), a_out(*)
      double precision avg_dbl

      t_all = float(npts - 1)/sps  ! assume t(1) = 0.0

      do i = 1, npts
        a_out(i) = 0.0
      end do

*  Determine the appropriate mean:
      if (t4mean_strt .lt. 0.0) then
        n_strt = 1
      else if (t4mean_strt .gt. t_all) then
        n_strt = 1
      else
        n_strt = nint(sps * t4mean_strt + 0.2) + 1
      end if

      if (t4mean_stop .lt. 0.0) then
        n_stop = npts
      else if (t4mean_stop .gt. t_all) then
        n_stop = npts
      else
        n_stop = nint(sps * t4mean_stop + 0.2) + 1
      end if

      n_t4mean = n_stop - n_strt + 1

      avg_dbl = 0.0d0
      do i = n_strt, n_stop
        avg_dbl = avg_dbl + dble(a_in(i))
      end do
      avg = sngl(avg_dbl/dble(n_t4mean))

*  Remove the mean from the whole record:

      do i = 1, npts
        a_out(i) = a_in(i) - avg
      end do

      return
      end
* ------------------------------------------------------------------ rmv_mean
