* ----------------------------- BEGIN DETREND ----------------
      subroutine detrend(y, n, itype)

* itype = 1: Removes a straightline fit to first and last points, replacing
* the input array with the detrended array
* itype = 2: Remove a least squares line fit to the whole record
* itype = 3: Remove a least squares quadratic fit to the whole record
* itype = 4: Remove a least squares cubic fit to the whole record

* Dates: 10/20/09 - written by D. Boore, patterned after rvmtrend.for

      external fpoly
!      external dfpoly

      real y(*), x(n), sig(n), c(11), covar(11,11), pd(2)
      integer ic(11)
      
      npc = 11

      if (itype .eq. 1) then
        y1 = y(1)
        y2 = y(n)
        slope = (y2 - y1)/float(n-1)

        do i = 1, n
          y(i) = y(i) - (y1 + slope*float(i-1))
        end do
        return
      end if

      do i = 1, n
        x(i) = float(i-1)
        sig(i) = 1.0
      end do
      
*   Now fit the curve:
     
      nc = iabs(itype-1) + 1
      
      c = 0.0

      do i = 1, nc
        ic(i)     = 1
      end do                

      call lfit(x, y, sig, n, c, ic, nc,
     :     covar, npc, chisq, fpoly)
!      call dlfit(x, y, sig, n, c, ic, nc,
!     :     covar, npc, chisq, dfpoly)
     
      nd = 2
     
      do i = 1, n
        xeval = float(i-1)
        call ddpoly(c, nc, xeval, pd, nd)
!        call dddpoly(c, nc, xeval, pd, nd)
        y(i) = y(i) - pd(1)
      end do

      
      return
      end
* ----------------------------- END DETREND ----------------

!      include '\forprogs\lfit.for'
!      include '\forprogs\fpoly.for'
!      include '\forprogs\ddpoly.for'
!      include '\forprogs\covsrt.for'
!      include '\forprogs\gaussj.for'
      
