*----------------- BEGIN Integrate_y -----------------------------
      subroutine integrate_y(y, npts, dt, rmv_trnd, y_int)


* Compute cumulative integral of y assuming that y is is represented
* by straight lines connecting the digitized values.

* Dates: 11/06/06 - Written by D.M. Boore, based on Acc2VD
 
      real y(*), y_int(*)
      
      logical rmv_trnd
      double precision cum_y_int, cumd, y1, y2, 
     : ddt, ddt_2

      if (rmv_trnd) then      
* remove trend first (straight line between first and last points)
* Note: acc is replaced with detrended time series
*        call dcdt(acc, dt, npts, 1, npts, .false., .true.)  ! old routine,
*                                                         ! gives steps at ends

         call rmvtrend(y, npts)
      end if

* compute integral, using analytical formulas based
* on representing the acceleration as a series of straightline segments.

      ddt     = dble(dt)
      ddt_2   = 0.5d0 * dble(dt)
 
      cum_y_int = 0.0d0
 
      y_int(1) = sngl(cum_y_int)
      do j=2,npts
        y1 = dble(y(j-1))
        y2 = dble(y(j))
        cum_y_int = cum_y_int + (y1 + y2)*ddt_2
        y_int(j) = sngl(cum_y_int)
      end do

      return
      end
*----------------- END integrate_y -----------------------------
