! ----------------------------------------------------- interpolate_time_series_linear
      subroutine interpolate_time_series_linear(
     : y_in, sps_in, npts_in, 
     : interpolate_factor,
     : y_out, sps_out, npts_out
     : )


! Interpolates an smc file to finer spacing, using 
! linear interpolation

! Dates: 11/19/12 - Written by D.M. Boore, patterned after interpolate_time_series_using_fork.
 
      real y_in(*), y_out(*) 
      integer npts_in, npts_out, npw2
      real sps_in, sps_out
 
      npts_interp = 0
      
      do i_in = 1, npts_in - 1
        
        slope = (y_in(i_in+1) - y_in(i_in))/real(interpolate_factor)
        
        do j = 1, interpolate_factor
        
          npts_interp = npts_interp + 1
          
          y_out(npts_interp) = y_in(i_in)+ slope * real(j-1)
          
        end do
        
      end do
      
! Store last point

      npts_interp = npts_interp + 1
          
      y_out(npts_interp) = y_in(npts_in)
      
      npts_out = npts_interp
      

      return
      end
! ----------------------------------------------------- interpolate_time_series_using_fork

 
