      subroutine pea_read(f_asc, nc_f_asc, nskip, 
     :              format4npts_dt, nc_format4npts_dt,
     :              comments, ncomments, xfactr,
     :              n_ts, dt, sps, ts)

! Dates: 10/07/09 - Written by D. Boore
!                 - Use format to be used in reading npts and dt

      character f_asc*(*), comments(*)*(*)
      character hdr_cmmnts(10)*200, format4npts_dt*(*) 
      real xfactr, dt, sps, ts(*)
      integer nc_f_asc, nu_asc, nskip, n_ts, ncomments
      integer nc_hdr_cmmnts(10)

      call get_lun(nu_asc)
       
      open(unit=nu_asc, file=f_asc(1:nc_f_asc), status='unknown')

      do i = 1, nskip
        hdr_cmmnts(i) = ' '
        read(nu_asc,'(a)') hdr_cmmnts(i)
        call trim_c(hdr_cmmnts(i), nc_hdr_cmmnts(i))
!        print *,' hdr_cmmnts:'//hdr_cmmnts(i)(1:nc_hdr_cmmnts(i))
      end do
      
      ncomments = 0
      ncomments = ncomments + 1
      comments(ncomments) = '|'
      do i = 1, nskip
        ncomments = ncomments + 1
        comments(ncomments) = '|'//hdr_cmmnts(i)(1:nc_hdr_cmmnts(i))
      end do

      if (format4npts_dt(1:nc_format4npts_dt) == '*') then
        read(nu_asc,*) n_ts, dt
      else
        read(nu_asc,format4npts_dt(1:nc_format4npts_dt)) n_ts, dt
      end if
 
      read(nu_asc,'(5e15.7)') (ts(i),i=1,n_ts)
      
      close(nu_asc)


* Scale the time series:
      do i = 1, n_ts
        ts(i) = xfactr * ts(i)
      end do

      sps = 1.0/dt

      end

! File from October 2020
!PEER NGA STRONG MOTION DATABASE RECORD
!2.02004e+13, 04/01/2020, AHID, BH1
!ACCELERATION TIME HISTORY IN UNITS OF G
!NPTS=  12000, DT=   0.025 SEC
!  6.3621196E-13  6.4829927E-13  6.9612136E-13  7.9523599E-13  9.5385152E-13
!  1.1725307E-12  1.4611407E-12  1.8351704E-12  2.3063396E-12  2.8851054E-12
!  3.5859117E-12  4.4176069E-12  5.3560307E-12  6.3121625E-12  7.1792642E-12
!  8.0120047E-12  9.3445859E-12  1.2282853E-11  1.7857320E-11  2.4662762E-11
!  2.7538781E-11  2.4737733E-11  2.1131909E-11  2.0074225E-11  2.1361306E-11
