
! ------------------------- BEGIN peak_trough_max_amp_period ---------
      subroutine peak_trough_max_amp_period(a, npts, dt, amp, period, 
     :                                      index_peak, time_peak)
      
! Dates: 04/05/10 - Written by D M. Boore
!        05/25/10 - Add index_peak, time_peak to output 
!                   (for testing purposes).

      real a(npts)
      
!      real extremum(:)
!      integer index_extremum(:)
      
       real extremum(npts)
       integer index_extremum(npts)
      
!      allocatable( extremum, index_extremum )
      
      ndimen_extremum = npts
      
!      allocate ( extremum(ndimen_extremum), 
!     :           index_extremum(ndimen_extremum) )
      
      call get_extrema(a, npts, 
     :   extremum, index_extremum, ndimen_extremum, nextrema)
     
! search for adjacent peaks and troughs, compute amp, period:

      amp = 0.0

      do i = 2, nextrema
        
        amp_new = abs(extremum(i) - extremum(i-1))
        if ( amp_new > amp) then
          amp = amp_new
          period = 2.0*dt*
     :       (index_extremum(i) - index_extremum(i-1))
          index_peak = index_extremum(i)     
        end if
      end do 
      
      amp = 0.5 * amp   ! an approximation of the maximum amplitude for magnitude calculations
      
      time_peak = dt*real(index_peak)
      
!      deallocate( extremum, index_extremum )
      
      return
      end
      
! ------------------------- END peak_trough_max_amp_period ---------

      