      subroutine period_from_zero_crossings(
     :     seism, npts, dt, eps4zc, nstart_zc, nstop_zc, zct)
      
! Measure period from zero crossings for portion of record
! between first and last occurrences of abs(seism)>= eps*absmax(seism);
! nstart and nstop correspond to these times.

! Dates: 05/24/10 - Written by D. Boore, based on old code

      real seism(*)

c
c period from zero crossings:
c

      nstart_zc = 1
      nstop_zc = npts
      ninc = 1
      call mnmax(seism,nstart_zc,nstop_zc,ninc,amin,amax) 
      if (abs(amin) > abs(amax)) then
        peak = abs(amin)
      else
        peak = abs(amax)
      end if

      amp_threshold = eps4zc * peak
      
      do i = 1, npts
        if (abs(seism(i)) >= amp_threshold) then
          nstart_zc = i
          exit
        end if
      end do
      
      do i = npts, 1, -1
        if (abs(seism(i)) >= amp_threshold) then
          nstop_zc = i
          exit
        end if
      end do

!DEBUG
!      write(*,*) ' eps4zc, peak, nstart_zc, nstop_zc = ',
!     :             eps4zc, peak, nstart_zc, nstop_zc
!DEBUG

      nzcrs = 0
      
! May want to only look between minimum amplitudes (no need to look at very amplitude portions)
      do i = nstart_zc, nstop_zc      
        if ( seism(i) * seism(i+1) < 0.0 )
     :     nzcrs = nzcrs + 1
      end do
      
      zct = 2.0 * real(nstop_zc-nstart_zc)*dt / float(nzcrs)

      return
      
      end

 