* ------------------------------------------------------------------- Rmv_CRLF
      Program Rmv_CRLF

* Removes carriage return/line feed characters and replaces with
* a blank, unless a double occurrence of CR/LF, in which case nothing
* is done (this signifies the end of the paragraph).

* Note the logic is not perfect, it will not work for a repeated string of 
* ichar(10), followed by ichar(13).

* Here is a sample control file:
*!Control file for program Rmv_CRLF
*! replaces CR/LF with space, unless doubled
*rose0104.tex
*rose0508.tex
*stop

* Dates: 10/19/01 - Written by D. Boore, patterned after Unix2PC

      character c_1*1, c_2*1, c_3*1, c_4*1
      character f_in*80, f_out*80, f_scr*80, c_stop*4

      character f_ctl*40, buf*80, comment(20)*80
      logical f_ctl_exist, f_in_exist, f_scr_exist, f_out_exist

      f_ctl_exist = .false.
      do while (.not. f_ctl_exist)
        f_ctl = ' '
        write(*, '(a\)') 
     :    ' Enter name of control file (cr to quit): '
        read(*, '(a)') f_ctl
        if (f_ctl .eq. ' ') stop
        inquire(file=f_ctl, exist=f_ctl_exist)
        if (.not. f_ctl_exist) then
          write(*,'(a)') ' ******* FILE DOES NOT EXIST ******* '
        end if
      end do

      call get_lun(nu_ctl)
      open(unit=nu_ctl,file=f_ctl,status='unknown')

      call skipcmnt(nu_ctl, comment, ncomments)

222   continue
      
      buf = ' '
      read(nu_ctl,'(a)') buf
      call trim_c(buf, nc_buf)
      c_stop = ' '
      c_stop = buf(1:4)
      call upstr(c_stop)
      if (c_stop .eq. 'STOP') then
        close(nu_ctl)
        stop
      end if

      f_in = ' '
      f_in = buf(1:nc_buf)
      call trim_c(f_in,nc_f_in)
* Check for existence of f_in:
      f_in_exist = .false.
      inquire(file=f_in, exist=f_in_exist)

      write(*,'(a)') ' f_in, f_in_exist = '//f_in
      write(*,*) f_in_exist

      if (.not. f_in_exist) then
        write(*,'(a)') ' File '//f_in(1:nc_buf)//
     :   ' does not exist; returning to control file'
        go to 222
      end if

      write(*,'(2a)') ' Reformatting file ', f_in(1:nc_buf)

      call get_lun(nu_in)
      open(unit=nu_in,file=f_in(1:nc_buf), position='rewind',
     :     access='transparent',form='unformatted',
     :     status='unknown')

* Check for existence of f_scr, and delete if it exists:
      f_scr = ' '
      f_scr = 'scratch.out'
      call trim_c(f_scr,nc_f_scr)
      f_scr_exist = .false.
      inquire(file=f_scr, exist=f_scr_exist)
      if (f_scr_exist) then
        call system('del '//f_scr(1:nc_f_scr))
      end if

      call get_lun(nu_scr)
      open(unit=nu_scr,file=f_scr, position='rewind',
     :     access='transparent',form='unformatted',
     :     status='unknown')

1000  continue
      c_1 = ' '
      read(nu_in, end = 2000) c_1
      if (ichar(c_1) .eq. 13) then
        c_2 = ' '
        read(nu_in, end = 2000) c_2
        if (ichar(c_2) .ne. 10) then
          write(nu_scr) c_1   
          write(nu_scr) c_2   
        else          
          c_3 = ' '
          read(nu_in, end = 2000) c_3
          c_4 = ' '
          read(nu_in, end = 2000) c_4
          if (ichar(c_3) .eq. 13 .and. ichar(c_4) .eq. 10) then
            write(nu_scr) c_1       ! double occurence; do nothing
            write(nu_scr) c_2
            write(nu_scr) c_3
            write(nu_scr) c_4
          else                   
            write(nu_scr) char(32)  ! replace CR/LF with a blank
            write(nu_scr) c_3
            write(nu_scr) c_4
          end if
        end if
      else
        write(nu_scr) c_1   
      end if  
      goto 1000
2000  continue

      close(nu_in)
      close(nu_scr)

* Copy scratch.out to f_out, delete scratch.out:

      f_out = f_in(1:nc_f_in)
      call trim_c(f_out,nc_f_out)
      
      f_out_exist = .false.
      inquire(file=f_out, exist=f_out_exist)
      if (f_out_exist) then
        call system('del '//f_out(1:nc_f_out))
      end if
      call system('copy '//f_scr(1:nc_f_scr)//' '//f_out(1:nc_f_out))
      call system('del '//f_scr(1:nc_f_scr))

      go to 222

      end
* ------------------------------------------------------------------- Rmv_CRLF

      include '\forprogs\get_lun.for'
      include '\forprogs\trim_c.for'
      include '\forprogs\upstr.for'
      include '\forprogs\skipcmnt.for'

